#!/bin/bash

powerdevilrc_path="$HOME/.kde/share/config/powerdevilrc"
profilerc_path="$HOME/.kde/share/config/powerdevilprofilesrc"

del_temp()
{
	echo -e "\n\n\033[1m使用者已中斷操作（Ctrl-C）\033[0m\n" 1>&2
	rm -f /tmp/powerdevilrc.$$
	rm -f /tmp/powerdevilprofilesrc.$$
	exit 1
}

gconf_failure_end()
{
	echo -e "\n\033[1m設定失敗：gconftool-2 執行錯誤\033[0m\n" 1>&2
}

write_failure_end()
{
	echo -e "\n\033[1m設定失敗：Powerdevil 設定檔寫入錯誤\033[0m\n" 1>&2
	rm -f /tmp/powerdevilrc.$$
	rm -f /tmp/powerdevilprofilesrc.$$
}

GNOME_setting()
{
	gconftool-2 --type int --set /apps/gnome-screensaver/idle_delay 0 || ( gconf_failure_end; return 1 )
	gconftool-2 --type string --set /apps/gnome-power-manager/actions/sleep_type_ac "hibernate" || ( gconf_failure_end; return 1 )
	gconftool-2 --type string --set /apps/gnome-power-manager/actions/sleep_type_battery "hibernate" || ( gconf_failure_end; return 1 )
	
	gconftool-2 --type int --set /apps/gnome-power-manager/timeout/sleep_display_ac $1 || ( gconf_failure_end; return 1 )
	gconftool-2 --type int --set /apps/gnome-power-manager/timeout/sleep_computer_ac $2 || ( gconf_failure_end; return 1 )
	gconftool-2 --type int --set /apps/gnome-power-manager/timeout/sleep_display_battery $1 || ( gconf_failure_end; return 1 )
	gconftool-2 --type int --set /apps/gnome-power-manager/timeout/sleep_computer_battery $2 || ( gconf_failure_end; return 1 )
	
	return 0
}


# Handle Ctrl-C interrupt

trap del_temp 2

# Read preferred hibernate values

sleep_display=10

sleep_computer=30



# Set GNOME

if which gconftool-2 > /dev/null; then
	#echo -e "\n\033[1m找到 GNOME gconftool-2，進行設定...\033[0m\n"
	if GNOME_setting `expr $sleep_display \* 60` `expr $sleep_computer \* 60`; then
		#echo -e "\033[1mGNOME 電源管理設定成功！\033[0m"
		if which gnome-power-preferences > /dev/null; then
			#echo -e "\033[1m按下 Enter 鍵觀看設定結果...\033[0m"
			#read
			gnome-power-preferences 1>/dev/null 2>/dev/null &
		fi
	fi
#else
	#echo -e "\n\033[1m略過 GNOME 電源管理設定：無法執行 gconftool-2\033[0m\n" 1>&2
fi

