
/*
  compile with:
    gcc -o epa epa.c $(pkg-config --cflags --libs gtk+-2.0 gmodule-2.0 gthread-2.0)

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
//#include <ctime.h>
#include <gtk/gtk.h>

gboolean toggle;   
gboolean toggle_about;   //紀錄"關於"視窗是否已開啟
gboolean toggle_timer;

//////////
//   全域變數

long start , finish;
long total_secs , last_secs;
int year,mon,mday;
int days , hours, mins, secs;
int character_num;
int psg_num;
GTimer *timer;
int count;
gboolean time_reuse;
gboolean time_using;


/////////////
///   函式

gboolean total_time(gpointer data);

void itemPressed(GtkMenuItem *menuItem, gpointer data);
void icon_act(GtkWidget *button, gpointer data);
int icon_click(GtkStatusIcon  *status_icon,    GdkEventButton *event,     gpointer        user_data) ;


static void icon_popup(GtkStatusIcon *status_icon,  guint  button, guint activate_time, gpointer   data);
static gint icon_popup_swap(GtkStatusIcon *widget,  GdkEvent *event);
static void icon_scroll(GtkStatusIcon *status_icon,  GdkEventScroll *event, gpointer   user_data);

void aboutClick(GtkMenuItem *menuItem, gpointer data);
void create_about_dialog();   //產生"關於"視窗

void shellClick(GtkMenuItem *menuItem, gpointer data);
void timer_click();
gpointer signal_thread(gpointer arg);
gboolean timeout_callback(gpointer data);
void remind_explain();
void remind_window();
char* power_msg();   //產生節能標語
void power_msg_dialog();

void draw_window();
gboolean expose_event_callback(GtkWidget *widget,  GdkEventExpose *event,   gpointer data);
gboolean expose_event_callback2(GtkWidget *widget,  GdkEventExpose *event,   gpointer data);

///////////////////////////
////
/////



GtkWidget* createFileMenuItem() {
   //////////////////////////
   //
   //  menuitem define

    GtkWidget *fileMenu;
    GtkWidget *openMenuItem;
    GtkWidget *saveMenuItem;
    GtkWidget *closeMenuItem;

    GtkWidget *aboutItem;

    GtkWidget *shellItem;
    GtkWidget *shellMenu;
    GtkWidget *shelldefault;
    GtkWidget *shellnever;
    GtkWidget *shellmanual;
    
    GtkWidget *powermsg;
    GtkWidget *draw_area;
    GtkWidget *timer;

   //////////////////////////
   //
   //  menuitem initialize
   
    fileMenu = gtk_menu_new();
    shellMenu = gtk_menu_new();

    closeMenuItem = gtk_menu_item_new_with_label("結束");

    aboutItem = gtk_menu_item_new_with_label("關於");
    timer = gtk_menu_item_new_with_label("定時休息提醒");
   
    shelldefault =     gtk_menu_item_new_with_label("預設");
    shellmanual  =     gtk_menu_item_new_with_label("自訂");
    shellnever   =     gtk_menu_item_new_with_label("永不啟動");
    shellItem    =     gtk_menu_item_new_with_label("電源配置");

    powermsg = gtk_menu_item_new_with_label("節能標語");
 //   draw_area= gtk_menu_item_new_with_label("draw_area");

    /////////////////////////////
    ///
    ///   add menuitem to menu

    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), aboutItem);
    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), timer);
    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), powermsg);  
 //   gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), draw_area);    

    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), shellItem);
    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), 
                          gtk_separator_menu_item_new());
    gtk_menu_shell_append(GTK_MENU_SHELL(fileMenu), closeMenuItem);

    

    gtk_menu_shell_append(GTK_MENU_SHELL(shellMenu), shelldefault);
    gtk_menu_shell_append(GTK_MENU_SHELL(shellMenu), shellnever);
    gtk_menu_shell_append(GTK_MENU_SHELL(shellMenu), shellmanual);

    gtk_menu_item_set_submenu(GTK_MENU_ITEM(shellItem), shellMenu);


   //////////////////////////
   //
   //    connect to signal

    g_signal_connect(GTK_OBJECT(aboutItem), "activate",
                     G_CALLBACK(aboutClick),  NULL);

    g_signal_connect(GTK_OBJECT(powermsg), "activate",
                     G_CALLBACK(icon_act),  NULL);
    g_signal_connect(GTK_OBJECT(timer), "activate",
                     G_CALLBACK(timer_click),  NULL);
 
  //  g_signal_connect(GTK_OBJECT(draw_area), "activate",
  //                   G_CALLBACK(draw_window),  NULL);
    
    g_signal_connect(GTK_OBJECT(closeMenuItem), "activate",
                     G_CALLBACK(gtk_main_quit), NULL);

    g_signal_connect(GTK_OBJECT(shelldefault), "activate",G_CALLBACK(shellClick), "1"); 
    g_signal_connect(GTK_OBJECT(shellnever), "activate",G_CALLBACK(shellClick), "2");
    g_signal_connect(GTK_OBJECT(shellmanual), "activate",G_CALLBACK(shellClick), "3");



    return fileMenu;
}

void w_destroy(GtkWidget *object , gpointer data){

   toggle = TRUE;
//   gtk_widget_destroy ( (GtkWidget*)data ); 

   gtk_main_quit();
}



int main(int argc, char *argv[]) {

   
    GtkStatusIcon *tray_icon;
    GtkWidget *menu; 
    GtkWidget *menu_items;
    char buf[128];
    int i;

   ///////////////////////
   ///  init
   ///

    toggle = TRUE;
    toggle_about = TRUE;
    toggle_timer = TRUE;

    time_reuse = FALSE;
    time_using = FALSE;

    gtk_init(&argc, &argv);

	
//	shellClick(NULL,"1");

   ///////////////////////////////////
   /// record date
   ///


	FILE * pFile;

 
	gchar *date_string;
	time_t now_raw;
	struct tm *now;
	

	now_raw = time(NULL);
	now = localtime(&now_raw);

	year = now->tm_year + 1900;
	mon  = now->tm_mon  + 1;
	mday = now->tm_mday;

	total_secs = 0 ; 
	days = 0 ; hours = 0 ; mins = 0 ; secs = 0;

    ////////////////////
    //  record init

//	pFile = fopen ("myfile.txt","w+");
//	fprintf (pFile, "%d %d %d \n", year,mon,mday);
//	fprintf (pFile, "%ld  \n", total_secs);
//	fclose (pFile);

	pFile = fopen ("myfile.txt" , "r");

   if (pFile == NULL){   // 若是沒有此檔案或開檔錯誤
	
	perror ("Error opening file");

	pFile = fopen ("myfile.txt","w+");
	fprintf (pFile, "%d %d %d \n", year,mon,mday);
	fprintf (pFile, "%ld  \n", total_secs);
	fclose (pFile);	
   }
   else
   {
    ////////////////////////
    ///   read record

	pFile = fopen ("myfile.txt", "r");
	fscanf (pFile, "%d %d %d \n", &year,&mon,&mday);
	fscanf (pFile, "%ld ", &last_secs );

	fclose (pFile);

   }



    //////////////////////////////
    //   紀錄累積時間
    //
	start = (long)time(NULL);
	
	//每10秒更新一次 record
	g_timeout_add(10000, (GSourceFunc) total_time, NULL);

    //set menu

    ///////////////////////////
    //  定時休眠提醒
    //
	count = 0;
	g_timeout_add(1000, (GSourceFunc) timeout_callback, "1111");

    //set  tray_icon 

    tray_icon = gtk_status_icon_new();

    gtk_status_icon_set_from_file(tray_icon, "./icon/Icon.ico");
    gtk_status_icon_set_tooltip(  tray_icon, "環保節能小助理");
    gtk_status_icon_set_visible(  tray_icon, TRUE);

    g_signal_connect(tray_icon, "activate" , G_CALLBACK(icon_act), NULL);
    g_signal_connect(tray_icon, "popup-menu" , G_CALLBACK(icon_popup), NULL);
    
   
  

    gtk_main();

    return 0;
}

gboolean total_time(gpointer data){
	FILE *pFile;


	finish = (long)time(NULL);

	long dif =  (finish - start);

	
//	g_print(" 程式已執行%ld秒 \n " ,  dif);

//	pFile = fopen ("myfile.txt","r");

//	fscanf (pFile, "%d %d %d \n", &year,&mon,&mday);

/*	fscanf (pFile, "%d", &days);
	fscanf (pFile, "%d", &hours);
	fscanf (pFile, "%d", &mins);
	fscanf (pFile, "%d", &secs);
*/
//	g_print(" last %ld 秒 \n ", last_secs );
	
	total_secs = last_secs + dif ;

	pFile = fopen ("myfile.txt","w");

	fprintf (pFile, "%d %d %d \n", year,mon,mday);
	fprintf (pFile, "%ld  \n", total_secs );
//	fprintf (pFile, "%d %d %d %d\n", days , hours, mins ,secs);
	

	fclose (pFile);

	return TRUE;	
	
	
	
}

void icon_act(GtkWidget *button, gpointer data) {
  //  g_print("activate\n");

    if(toggle == TRUE ){
	toggle = FALSE ; 
//	g_print(" toggle is TRUE \n" );

        draw_window();
    }
    else{
//	toggle = TRUE ; 
//	g_print(" toggle is FALSE \n" );
    }

   
}


static void icon_popup(GtkStatusIcon *status_icon,  guint  button, guint activate_time, gpointer   data){

    GtkWidget *menu; 
    GtkWidget *menu_items;
    char buf[128];
    int i;


        //set menu

    menu = createFileMenuItem() ;

    gtk_menu_popup  ( GTK_MENU(menu), NULL,NULL, NULL,data,  button, activate_time);

    gtk_widget_show_all(menu);
  //  g_print(" pupop menu\n");
   
} 



static void icon_scroll(GtkStatusIcon *status_icon,  GdkEventScroll *event, gpointer   user_data){

    printf("scroll  %s\n" , (char *)user_data);

}   

void aboutClick(GtkMenuItem *menuItem, gpointer data){


   if(toggle_about == TRUE ){
	toggle_about = FALSE ; 
//	g_print(" toggle_about is TRUE \n" );

        create_about_dialog();
    }
    else{
//	toggle = TRUE ; 
//	g_print(" toggle_about is FALSE \n" );
    }

}

void create_about_dialog(){
   GtkWidget *dialog;
   GdkPixbuf *logo;
   GError *error = NULL;

   dialog = gtk_about_dialog_new();

   logo = gdk_pixbuf_new_from_file("./icon/AboutBack.jpg", &error);
   if(error == NULL){
      gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG(dialog), logo);
   }
   else{
      g_print("Error: %s\n", error->message);
      g_error_free(error);
   }

   gtk_about_dialog_set_name( GTK_ABOUT_DIALOG(dialog) , "環保節能小助理");
   gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(dialog) , "http://www.epa.gov.tw");
   gtk_dialog_run( GTK_DIALOG(dialog));
   gtk_widget_destroy(dialog);

   toggle_about = TRUE;

}

void timer_click(){

    if(toggle_timer == TRUE ){
	toggle_timer = FALSE;
	remind_explain();
    }
    else{
//	toggle = TRUE ; 
//	g_print(" toggle_timer is FALSE \n" );
    }



}


gboolean timeout_callback(gpointer data) {
  

    // 若是不到30分鐘 (1800秒) 則累加count 
    if(count < 1800) {
//	g_printf(" timeout : %d \n",count);
        count++;
        return TRUE;
    }
    else {
//	g_printf(" end\n");
	
	remind_window();

	count = 0;
        return TRUE;
    }
}

void remind_explain(){
    GtkWidget *dialog;

    dialog = gtk_message_dialog_new(NULL, 
                             GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, 
                             GTK_BUTTONS_OK, "每30分鐘會自動提醒您休息");
    gtk_window_set_title(GTK_WINDOW(dialog), "定時休息提醒");
    

    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
    
    toggle_timer = TRUE;
}

void remind_window(){
    GtkWidget *dialog;

    dialog = gtk_message_dialog_new(NULL, 
                             GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, 
                             GTK_BUTTONS_OK, "請休息一下 保護眼睛");
    gtk_window_set_title(GTK_WINDOW(dialog), "定時休息提醒");
    

    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
    
    toggle_timer = TRUE;
}

char* power_msg(){

        srand ( time(NULL) );
	GString  *str ;
       
        int num = rand() % 10;

	str = g_string_new(""); 

        char  *Title[] = {
		"冷氣控溫不外洩：", "隨手關燈拔插頭：",
		"節能省水更省錢：", "綠色採購看標章：",
		"鐵馬步行兼保健：", "每週一天不開車：",
		"選車用車助減碳：", "多吃蔬食少吃肉：",
		"自備杯筷帕與袋：", "惜用資源顧地球："
	};

	char  *Content[] = {
		"少開冷氣，多開窗；",
		"非特定場合不穿西裝領帶；",
		"冷氣控溫-28℃且不外洩。", // 1
		"隨手關燈關機、拔插頭；",
		"檢討採光需求，提升照明",
		"績效，減少多餘燈管數。", // 2
		"將傳統鎢絲燈泡逐步改為",
		"省電燈泡，一樣亮度更省電、",
		"壽命更長、更省錢。", // 3
		"選購環保標章、節能標章、",
		"省水標章及EER 值高的商品，",
		"節能減碳又環保。", // 4
		"多走樓梯，少坐電梯，",
		"上班外出常騎鐵馬，多走路，",
		"增加運動健身的時間。", // 5
		"多搭乘公共運輸工具；",
		"減少一人開車騎機車次數；",
		"每週至少一天不開車。", // 6
		"選用油氣雙燃料、",
		"油電混合或電動車輛或動力",
		"機具，養成停車就熄火習慣。", // 7
		"愛用當地食材；每週一天",
		"或一日一餐蔬食；",
		"吃多少點多少，減少碳排量。", // 8
		"自備隨身杯、環保筷、",
		"手帕及購物袋；少喝瓶裝水；",
	        "少用一次即丟商品。", // 9
		"雙面用紙；選用再生紙、",
		"省水龍頭及馬桶；不用",
		"過度包裝商品；回收資源。" // 10
	};

     g_string_append( str , Title[num]);
     g_string_append( str , "\n\n");
     g_string_append( str , Content[num*3 + 0]);
     g_string_append( str , "\n");
     g_string_append( str , Content[num*3 + 1]);
     g_string_append( str , "\n");
     g_string_append( str , Content[num*3 + 2]);
     g_string_append( str , "\n");
   
    
       return str->str;


}

void power_msg_dialog(){

     printf("%s \n" , power_msg());



}

void shellClick(GtkMenuItem *menuItem, gpointer data){

 //  printf("shell %s \n" ,  (char *)data);

   if( data == "1" )
     system("./PSAdefault.sh");
   else if (data=="2")
     system("./PSAnever.sh");
   else if (data=="3")
     system("gnome-power-preferences 1>/dev/null 2>/dev/null ");

}

void itemPressed(GtkMenuItem *menuItem, gpointer data) {
    
   g_print("%s\n", (char *)data);
}

void draw_window(){
    GtkWidget *window;
    GtkWidget *drawing_area;

 	srand ( time(NULL) );
       
        character_num = rand() % 4;
        psg_num = rand() % 10;
   
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window), "環保節能小助理");

    drawing_area = gtk_drawing_area_new();
    gtk_widget_set_size_request(drawing_area, 600, 330);

/////////////////////
///

       

    g_signal_connect(GTK_OBJECT(drawing_area), "expose_event",  G_CALLBACK(expose_event_callback2), power_msg());

    gtk_container_add(GTK_CONTAINER(window), drawing_area);

    g_signal_connect(GTK_OBJECT(window), "destroy",
                     G_CALLBACK(w_destroy), NULL);
                     
    gtk_widget_show_all(window);

    gtk_main();

}


gboolean expose_event_callback2(GtkWidget *widget,  GdkEventExpose *event,   gpointer data) {
                               
    GdkGC *gc = widget->style->fg_gc[GTK_WIDGET_STATE(widget)];
    GdkDrawable *drawable = widget->window;
    GdkColor color;
    GdkFont *font;

	GString  *str ;
          
	str = g_string_new(""); 

        char  *Pic[] = {
		"./icon/BBear.png", "./icon/WBear.png",
		"./icon/Girl.png" , "./icon/Transformer.png",
		
	};

        char  *Title[] = {
		"冷氣控溫不外洩：", "隨手關燈拔插頭：",
		"節能省水更省錢：", "綠色採購看標章：",
		"鐵馬步行兼保健：", "每週一天不開車：",
		"選車用車助減碳：", "多吃蔬食少吃肉：",
		"自備杯筷帕與袋：", "惜用資源顧地球："
	};

	char  *Content[] = {
		"少開冷氣，多開窗；",
		"非特定場合不穿西裝領帶；",
		"冷氣控溫-28℃且不外洩。", // 1
		"隨手關燈關機、拔插頭；",
		"檢討採光需求，提升照明",
		"績效，減少多餘燈管數。", // 2
		"將傳統鎢絲燈泡逐步改為",
		"省電燈泡，一樣亮度更省電、",
		"壽命更長、更省錢。", // 3
		"選購環保標章、節能標章、",
		"省水標章及EER 值高的商品，",
		"節能減碳又環保。", // 4
		"多走樓梯，少坐電梯，",
		"上班外出常騎鐵馬，多走路，",
		"增加運動健身的時間。", // 5
		"多搭乘公共運輸工具；",
		"減少一人開車騎機車次數；",
		"每週至少一天不開車。", // 6
		"選用油氣雙燃料、",
		"油電混合或電動車輛或動力",
		"機具，養成停車就熄火習慣。", // 7
		"愛用當地食材；每週一天",
		"或一日一餐蔬食；",
		"吃多少點多少，減少碳排量。", // 8
		"自備隨身杯、環保筷、",
		"手帕及購物袋；少喝瓶裝水；",
	        "少用一次即丟商品。", // 9
		"雙面用紙；選用再生紙、",
		"省水龍頭及馬桶；不用",
		"過度包裝商品；回收資源。" // 10
	};

     g_string_append( str , Content[psg_num*3 + 0]);
     g_string_append( str , "\n");
     g_string_append( str , Content[psg_num*3 + 1]);
     g_string_append( str , "\n");
     g_string_append( str , Content[psg_num*3 + 2]);
     g_string_append( str , "\n");

    //////////////////////////////
    // 畫背景圖
    gdk_draw_pixbuf(drawable, gc, gdk_pixbuf_new_from_file("./icon/MsgBack.jpg", NULL)
            , 0, 0, 10, 10, -1, -1, 
            GDK_RGB_DITHER_NORMAL, 0, 0);

    
   ////////////////////
   // 畫出人物小圖

    gdk_draw_pixbuf(drawable, gc, gdk_pixbuf_new_from_file( Pic[character_num], NULL)
            , 0, 0, 400, 170, -1, -1, 
            GDK_RGB_DITHER_NORMAL, 0, 0);

    //////////////////////////
    // 畫出Title



	color.red = 65535;
	color.green = 0;
	color.blue = 0;
	gdk_gc_set_rgb_fg_color(gc, &color);


	PangoLayout* PL;
	PL =  gtk_widget_create_pango_layout (widget,  Title[psg_num]);

	gdk_draw_layout    (drawable, gc, 350,  50,  PL);

    //////////////////
    // 畫出Content
    //

	color.red = 0;
	color.green = 0;
	color.blue = 0;
	gdk_gc_set_rgb_fg_color(gc, &color);

	PL =  gtk_widget_create_pango_layout (widget,  str->str);



	gdk_draw_layout    (drawable, gc, 350,  80,  PL);

    //////////////////	
    //  畫出耗電量資訊
    //  
	int WattPerHour = 120;
	long double eCount;
	long double eCO2;
	long eDay , eHour , eMin , eSec;
        str = g_string_new(""); 

	FILE * pFile;

	finish = (long)time(NULL);

	long dif =  (finish - start);

	pFile = fopen ("myfile.txt","r");

	fscanf (pFile, "%d %d %d \n", &year,&mon,&mday);
	fclose (pFile);

   	total_secs = last_secs + dif;

	eSec = total_secs;
	eHour = eSec / 3600 ;
	eSec %= 3600 ;
	eMin = eSec /60 ;
	eSec %= 60 ;
	eDay = eHour /24 ;
	eHour %= 24;


	eCount = (long double)total_secs / 3600 * WattPerHour /1000;
	eCO2 = eCount * 0.636 ;
     
     g_string_printf( str , "程式安裝日期: %d年%d月%d日 \n\n" , year, mon, mday);
     g_string_append_printf( str , "累計執行時間: %ld日%ld時%ld分%ld秒 \n" , eDay, eHour , eMin , eSec);
     g_string_append_printf( str , "累計耗電量  : %.3Lf 度\n" , eCount);
     g_string_append_printf( str , "累計產生CO2量 : %.3Lf 公斤  \n " , eCO2);

	PL =  gtk_widget_create_pango_layout (widget,  str->str);
    
     


	gdk_draw_layout    (drawable, gc, 30,  80,  PL);


    //////////////////
    // 前景顏色調回來
    //

	color.red = 0;
	color.green = 0;
	color.blue = 0;
	gdk_gc_set_rgb_fg_color(gc, &color);

    

    return TRUE;
}


